
#ifndef CUX_H
#define CUX_H
#endif

#ifndef byte
#define byte uint8_t
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE 1
#endif


#define _pid01 FALSE  //monitor status    4
#define _pid02 FALSE  //freeze dtc      2
#define _pid03 FALSE  //fuel system status    2
#define _pid04 FALSE  //calculated engine load  1
#define _pid05 TRUE //engine coolant temp   1
#define _pid06 FALSE  //STFT bank 1     1
#define _pid07 FALSE  //LTFT bank 1     1
#define _pid08 FALSE  //STFT bank 2     1
#define _pid09 FALSE  //LTFT bank 2     1
#define _pid0A FALSE  //Fuel pressure     1
#define _pid0B FALSE  //Intake MAP      1
#define _pid0C TRUE //RPM       2
#define _pid0D TRUE //Vehicle Speed     1
#define _pid0E FALSE  //Timing Advance    1   
#define _pid0F TRUE //IAT       1
#define _pid10 FALSE  //MAF flow rate     2
#define _pid11 TRUE //TPS       1
#define _pid12 FALSE  //commanded secondary air status
#define _pid13 FALSE  //O2 sensors present in 2 banks
#define _pid14 FALSE  //O2S1  Voltage/STFT
#define _pid15 FALSE  //O2S1  Voltage/STFT
#define _pid16 FALSE  //O2S1  Voltage/STFT
#define _pid17 FALSE  //O2S1  Voltage/STFT
#define _pid18 FALSE  //O2S1  Voltage/STFT
#define _pid19 FALSE  //O2S1  Voltage/STFT
#define _pid1A FALSE  //O2S1  Voltage/STFT
#define _pid1B FALSE  //O2S1  Voltage/STFT
#define _pid1C FALSE  //OBD Conformance standards
#define _pid1D FALSE  //o2 sensors present in 4 banks
#define _pid1E FALSE  //aux input status
#define _pid1F FALSE  //run time since engine start
#define _pid20 FALSE  //pidS 21-40 supported



#define _tpsAddress 0x005F
#define _coolantTempAddress 0x006A
#define _rpmAddress 0x007C
#define _mphAddress 0x2003

#define _tpsLength 2
#define _coolantTempLength 1
#define _rpmLength 2
#define _mphLength 1
#define _messageFixedId 0
#define _readMessagePrefix 3
#define _writeMessagePrefix 2


bool CUX_initialize();
int PID (byte *_ISO_message,byte _ISO_messageLength,byte *dest);
int PID0100 (byte *dest);  //PID available list
int PID0105(byte *dest);  //coolant temp
int PID010C(byte *dest);  //RPM
int PID010D(byte *dest); //Kilometers per hour
int PID010F(byte *dest);  //intake temp
int PID0111(byte *dest);  //TPS

void  CUX_resetWriteBits();
void CUX_startScanLoop();
void CUX_stopScanLoop();
bool CUX_isScanRunning();
void CUX_update(double currentTime);
void coolantUpdate();
